diff -r 1d1c4c997b66 sys/amd64/conf/MPTCP
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/amd64/conf/MPTCP	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,15 @@
+include		GENERIC
+
+options		KDB
+options		DDB
+
+options		ALQ
+
+options		BREAK_TO_DEBUGGER
+options 	ALT_BREAK_TO_DEBUGGER
+
+options 	IPFIREWALL
+options 	IPFIREWALL_DEFAULT_TO_ACCEPT
+
+nooptions	INET6
+nooptions	IPSEC
diff -r 1d1c4c997b66 sys/conf/files
--- a/sys/conf/files	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/conf/files	Sun Aug 30 14:27:42 2015 +1000
@@ -3474,6 +3474,11 @@
 netinet/raw_ip.c		optional inet | inet6
 netinet/cc/cc.c			optional inet | inet6
 netinet/cc/cc_newreno.c		optional inet | inet6
+netinet/mptcp_subr.c 		optional inet | inet6
+netinet/mptcp_timer.c 		optional inet | inet6
+netinet/mptcp_pcb.c 		optional inet | inet6
+netinet/mptcp_usrreq.c 		optional inet
+netinet/mptcp_handshake.c 	optional inet
 netinet/sctp_asconf.c		optional inet sctp | inet6 sctp
 netinet/sctp_auth.c		optional inet sctp | inet6 sctp
 netinet/sctp_bsd_addr.c		optional inet sctp | inet6 sctp
diff -r 1d1c4c997b66 sys/conf/kern.pre.mk
--- a/sys/conf/kern.pre.mk	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/conf/kern.pre.mk	Sun Aug 30 14:27:42 2015 +1000
@@ -47,9 +47,9 @@
 .endif
 .if ${MACHINE_CPUARCH} == "amd64"
 .if ${COMPILER_TYPE} == "clang"
-COPTFLAGS?=-O2 -pipe
+COPTFLAGS?=-O0 -pipe
 .else
-COPTFLAGS?=-O2 -frename-registers -pipe
+COPTFLAGS?=-O0 -frename-registers -pipe
 .endif
 .else
 COPTFLAGS?=${_MINUS_O} -pipe
diff -r 1d1c4c997b66 sys/kern/uipc_socket.c
--- a/sys/kern/uipc_socket.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/kern/uipc_socket.c	Sun Aug 30 14:27:42 2015 +1000
@@ -110,6 +110,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/fcntl.h>
+#include <sys/kdb.h>
 #include <sys/limits.h>
 #include <sys/lock.h>
 #include <sys/mac.h>
@@ -126,6 +127,7 @@
 #include <sys/poll.h>
 #include <sys/proc.h>
 #include <sys/protosw.h>
+#include <sys/queue.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/resourcevar.h>
@@ -141,6 +143,11 @@
 
 #include <net/vnet.h>
 
+#include <netinet/in.h>
+#include <netinet/in_pcb.h>
+#include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
+
 #include <security/mac/mac_framework.h>
 
 #include <vm/uma.h>
@@ -671,6 +678,11 @@
 	return (so);
 }
 
+struct socket *
+gsoalloc(struct vnet *vnet) {
+	return soalloc(vnet);
+}
+
 int
 sobind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
@@ -832,6 +844,7 @@
 	sodealloc(so);
 }
 
+
 /*
  * Close a socket on last file table reference removal.  Initiate disconnect
  * if connected.  Free socket when disconnect complete.
@@ -1393,6 +1406,7 @@
 	error = so->so_proto->pr_usrreqs->pru_sosend(so, addr, uio, top,
 	    control, flags, td);
 	CURVNET_RESTORE();
+
 	return (error);
 }
 
@@ -2028,6 +2042,7 @@
 	goto restart;
 
 deliver:
+
 	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
 	KASSERT(sbavail(sb) > 0, ("%s: sockbuf empty", __func__));
 	KASSERT(sb->sb_mb != NULL, ("%s: sb_mb == NULL", __func__));
@@ -2125,6 +2140,225 @@
 	return (error);
 }
 
+
+///*
+// *  Modified version of soreceive_stream() for Multipath-enabled
+// *  connections
+// */
+//int
+//soreceive_mpstream(struct socket *so, struct sockaddr **psa, struct uio *uio,
+//    struct mbuf **mp0, struct mbuf **controlp, int *flagsp)
+//{
+//	int len = 0, error = 0, flags, oresid;
+//	struct mbuf *n = NULL, *m;
+//	struct mpcb *mp;
+//	struct sockbuf *sb;
+//	struct tcpcb *tp = sototcpcb(so);
+//
+//	if(!tp)
+//		return(EINVAL);
+//
+//	mp = tp->t_pcb_ref.mp;
+//	KASSERT(mp != NULL, ("%s Doing mpstream re-assembly without a valid mp block\n" ,__func__));
+//
+//	/* We only do stream sockets. */
+//	if (so->so_type != SOCK_STREAM)
+//		return (EINVAL);
+//	if (psa != NULL)
+//		*psa = NULL;
+//	if (controlp != NULL)
+//		return (EINVAL);
+//	if (flagsp != NULL)
+//		flags = *flagsp &~ MSG_EOR;
+//	else
+//		flags = 0;
+//	if (flags & MSG_OOB)
+//		return (soreceive_rcvoob(so, uio, flags));
+//	if (mp0 != NULL)
+//		*mp0 = NULL;
+//
+//	sb = &so->so_rcv;
+//
+//	/* Prevent other readers from entering the socket. */
+//	error = sblock(sb, SBLOCKWAIT(flags));
+//	if (error)
+//		goto out;
+//	SOCKBUF_LOCK(sb);
+//
+//	//mp_do_reass(so);
+//
+//	/* Easy one, no space to copyout anything. */
+//	if (uio->uio_resid == 0) {
+//		error = EINVAL;
+//		goto out;
+//	}
+//	oresid = uio->uio_resid;
+//
+//	/* We will never ever get anything unless we are or were connected. */
+//	if (!(so->so_state & (SS_ISCONNECTED|SS_ISDISCONNECTED))) {
+//		error = ENOTCONN;
+//		goto out;
+//	}
+//
+//restart:
+//	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
+//
+//	/* Abort if socket has reported problems. */
+//	if (so->so_error) {
+//		if (sb->sb_cc > 0)
+//			goto deliver;
+//		if (oresid > uio->uio_resid)
+//			goto out;
+//		error = so->so_error;
+//		if (!(flags & MSG_PEEK))
+//			so->so_error = 0;
+//		goto out;
+//	}
+//
+//	/* Door is closed.  Deliver what is left, if any. */
+//	if (sb->sb_state & SBS_CANTRCVMORE) {
+//		if (sb->sb_cc > 0)
+//			goto deliver;
+//		else
+//			goto out;
+//	}
+//
+//	/*
+//	 * If the last received sequence is less than what
+//	 * was expected.
+//	 */
+////	if (tp->mp_enabled) {
+////		if ((mp->ds_rcv_nxt - mp->ds_last_rcvd ) >= 0)
+////			goto out;
+////	}
+//
+//	/* Socket buffer is empty and we shall not block. */
+//	if (sb->sb_cc == 0 &&
+//	    ((so->so_state & SS_NBIO) || (flags & (MSG_DONTWAIT|MSG_NBIO)))) {
+//		error = EAGAIN;
+//		goto out;
+//	}
+//
+//	/* Socket buffer got some data that we shall deliver now. */
+//	if (sb->sb_cc > 0 && !(flags & MSG_WAITALL) &&
+//	    ((sb->sb_flags & SS_NBIO) ||
+//	     (flags & (MSG_DONTWAIT|MSG_NBIO)) ||
+//	     sb->sb_cc >= sb->sb_lowat ||
+//	     sb->sb_cc >= uio->uio_resid ||
+//	     sb->sb_cc >= sb->sb_hiwat) ) {
+//		goto deliver;
+//	}
+//
+//	/* On MSG_WAITALL we must wait until all data or error arrives. */
+//	if ((flags & MSG_WAITALL) &&
+//	    (sb->sb_cc >= uio->uio_resid || sb->sb_cc >= sb->sb_lowat))
+//		goto deliver;
+//
+//	/*
+//	 * Wait and block until (more) data comes in.
+//	 * NB: Drops the sockbuf lock during wait.
+//	 */
+//	error = sbwait(sb);
+//	if (error)
+//		goto out;
+//	goto restart;
+//
+//deliver:
+//	SOCKBUF_LOCK_ASSERT(&so->so_rcv);
+//	KASSERT(sb->sb_cc > 0, ("%s: sockbuf empty", __func__));
+//	KASSERT(sb->sb_mb != NULL, ("%s: sb_mb == NULL", __func__));
+//
+//	/* Statistics. */
+//	if (uio->uio_td)
+//		uio->uio_td->td_ru.ru_msgrcv++;
+//
+//	/* Fill uio until full or current end of socket buffer is reached. */
+//	len = min(uio->uio_resid, sb->sb_cc);
+//
+////printf("%s: deliver len %d\n",__func__, len);
+//	if (mp0 != NULL) {
+//		/* Dequeue as many mbufs as possible. */
+//		if (!(flags & MSG_PEEK) && len >= sb->sb_mb->m_len) {
+//			for (*mp0 = m = sb->sb_mb;
+//			     m != NULL && m->m_len <= len;
+//			     m = m->m_next) {
+//				len -= m->m_len;
+//				uio->uio_resid -= m->m_len;
+//				sbfree(sb, m);
+//				n = m;
+//			}
+//			sb->sb_mb = m;
+//			if (sb->sb_mb == NULL)
+//				SB_EMPTY_FIXUP(sb);
+//			n->m_next = NULL;
+//		}
+//		/* Copy the remainder. */
+//		if (len > 0) {
+//			KASSERT(sb->sb_mb != NULL,
+//			    ("%s: len > 0 && sb->sb_mb empty", __func__));
+//
+//			m = m_copym(sb->sb_mb, 0, len, M_NOWAIT);
+//			if (m == NULL)
+//				len = 0;	/* Don't flush data from sockbuf. */
+//			else
+//				uio->uio_resid -= m->m_len;
+//			if (*mp0 != NULL)
+//				n->m_next = m;
+//			else
+//				*mp0 = m;
+//			if (*mp0 == NULL) {
+//				error = ENOBUFS;
+//				goto out;
+//			}
+//		}
+//	} else {
+//		/* NB: Must unlock socket buffer as uiomove may sleep. */
+//
+//		SOCKBUF_UNLOCK(sb);
+//		error = m_mbuftouio(uio, sb->sb_mb, len);
+//		SOCKBUF_LOCK(sb);
+//
+//		if (error)
+//			goto out;
+//	}
+//	SBLASTRECORDCHK(sb);
+//	SBLASTMBUFCHK(sb);
+//
+//	/*
+//	 * Remove the delivered data from the socket buffer unless we
+//	 * were only peeking.
+//	 */
+//	if (!(flags & MSG_PEEK)) {
+//		if (len > 0)
+//			sbdrop_locked(sb, len);
+//
+//		/* Notify protocol that we drained some data. */
+//		if ((so->so_proto->pr_flags & PR_WANTRCVD) &&
+//		    (((flags & MSG_WAITALL) && uio->uio_resid > 0) ||
+//		     !(flags & MSG_SOCALLBCK))) {
+//			SOCKBUF_UNLOCK(sb);
+//			VNET_SO_ASSERT(so);
+//			(*so->so_proto->pr_usrreqs->pru_rcvd)(so, flags);
+//			SOCKBUF_LOCK(sb);
+//		}
+//	}
+//
+//	/*
+//	 * For MSG_WAITALL we may have to loop again and wait for
+//	 * more data to come in.
+//	 */
+//	if ((flags & MSG_WAITALL) && uio->uio_resid > 0)
+//		goto restart;
+//out:
+//
+//	SOCKBUF_LOCK_ASSERT(sb);
+//	SBLASTRECORDCHK(sb);
+//	SBLASTMBUFCHK(sb);
+//	SOCKBUF_UNLOCK(sb);
+//	sbunlock(sb);
+//	return (error);
+//}
+
 /*
  * Optimized version of soreceive() for simple datagram cases from userspace.
  * Unlike in the stream case, we're able to drop a datagram if copyout()
@@ -3049,6 +3283,52 @@
 }
 
 int
+sopoll_mpstream(struct socket *so, int events, struct ucred *active_cred,
+    struct thread *td)
+{
+	int revents = 0;
+
+	SOCKBUF_LOCK(&so->so_snd);
+	SOCKBUF_LOCK(&so->so_rcv);
+	if (events & (POLLIN | POLLRDNORM))
+		if (soreadabledata(so))
+			revents |= events & (POLLIN | POLLRDNORM);
+
+	if (events & (POLLOUT | POLLWRNORM))
+		if (sowriteable(so))
+			revents |= events & (POLLOUT | POLLWRNORM);
+
+	if (events & (POLLPRI | POLLRDBAND))
+		if (so->so_oobmark || (so->so_rcv.sb_state & SBS_RCVATMARK))
+			revents |= events & (POLLPRI | POLLRDBAND);
+
+	if ((events & POLLINIGNEOF) == 0) {
+		if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
+			revents |= events & (POLLIN | POLLRDNORM);
+			if (so->so_snd.sb_state & SBS_CANTSENDMORE)
+				revents |= POLLHUP;
+		}
+	}
+
+	if (revents == 0) {
+		if (events & (POLLIN | POLLPRI | POLLRDNORM | POLLRDBAND)) {
+			selrecord(td, &so->so_rcv.sb_sel);
+			so->so_rcv.sb_flags |= SB_SEL;
+		}
+
+		if (events & (POLLOUT | POLLWRNORM)) {
+			selrecord(td, &so->so_snd.sb_sel);
+			so->so_snd.sb_flags |= SB_SEL;
+		}
+	}
+
+	SOCKBUF_UNLOCK(&so->so_rcv);
+	SOCKBUF_UNLOCK(&so->so_snd);
+	return (revents);
+}
+
+
+int
 soo_kqfilter(struct file *fp, struct knote *kn)
 {
 	struct socket *so = kn->kn_fp->f_data;
diff -r 1d1c4c997b66 sys/netinet/in_pcb.c
--- a/sys/netinet/in_pcb.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/in_pcb.c	Sun Aug 30 14:27:42 2015 +1000
@@ -326,6 +326,69 @@
 	return (error);
 }
 
+/*
+ * Allocate a PCB and associate it with the socket.
+ * On success return with the PCB locked.
+ */
+struct inpcb *
+in_pcballoc_subflow(struct socket *so, struct inpcbinfo *pcbinfo)
+{
+	struct inpcb *inp;
+	int error;
+
+	INP_INFO_WLOCK_ASSERT(pcbinfo);
+	error = 0;
+	inp = uma_zalloc(pcbinfo->ipi_zone, M_NOWAIT);
+	if (inp == NULL)
+		return inp;
+
+	bzero(inp, inp_zero_size);
+	inp->inp_pcbinfo = pcbinfo;
+	inp->inp_socket = so;
+	inp->inp_cred = crhold(so->so_cred);
+	inp->inp_inc.inc_fibnum = so->so_fibnum;
+#ifdef MAC
+	error = mac_inpcb_init(inp, M_NOWAIT);
+	if (error != 0)
+		goto out;
+	mac_inpcb_create(so, inp);
+#endif
+#ifdef IPSEC
+	error = ipsec_init_policy(so, &inp->inp_sp);
+	if (error != 0) {
+#ifdef MAC
+		mac_inpcb_destroy(inp);
+#endif
+		goto out;
+	}
+#endif /*IPSEC*/
+#ifdef INET6
+	if (INP_SOCKAF(so) == AF_INET6) {
+		inp->inp_vflag |= INP_IPV6PROTO;
+		if (V_ip6_v6only)
+			inp->inp_flags |= IN6P_IPV6_V6ONLY;
+	}
+#endif
+	LIST_INSERT_HEAD(pcbinfo->ipi_listhead, inp, inp_list);
+	pcbinfo->ipi_count++;
+#ifdef INET6
+	if (V_ip6_auto_flowlabel)
+		inp->inp_flags |= IN6P_AUTOFLOWLABEL;
+#endif
+	INP_WLOCK(inp);
+	inp->inp_gencnt = ++pcbinfo->ipi_gencnt;
+	refcount_init(&inp->inp_refcount, 1);	/* Reference from inpcbinfo */
+#if defined(IPSEC) || defined(MAC)
+out:
+	if (error != 0) {
+		crfree(inp->inp_cred);
+		uma_zfree(pcbinfo->ipi_zone, inp);
+		inp = NULL;
+	}
+#endif
+	return (inp);
+}
+
 #ifdef INET
 int
 in_pcbbind(struct inpcb *inp, struct sockaddr *nam, struct ucred *cred)
@@ -1079,6 +1142,7 @@
 		if (error)
 			return (error);
 	}
+
 	oinp = in_pcblookup_hash_locked(inp->inp_pcbinfo, faddr, fport,
 	    laddr, lport, 0, NULL);
 	if (oinp != NULL) {
@@ -1293,7 +1357,6 @@
 void
 in_pcbdrop(struct inpcb *inp)
 {
-
 	INP_WLOCK_ASSERT(inp);
 
 	/*
diff -r 1d1c4c997b66 sys/netinet/in_pcb.h
--- a/sys/netinet/in_pcb.h	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/in_pcb.h	Sun Aug 30 14:27:42 2015 +1000
@@ -632,6 +632,8 @@
 
 void	in_pcbpurgeif0(struct inpcbinfo *, struct ifnet *);
 int	in_pcballoc(struct socket *, struct inpcbinfo *);
+struct inpcb *
+	in_pcballoc_subflow(struct socket *so, struct inpcbinfo *pcbinfo);
 int	in_pcbbind(struct inpcb *, struct sockaddr *, struct ucred *);
 int	in_pcb_lport(struct inpcb *, struct in_addr *, u_short *,
 	    struct ucred *, int);
diff -r 1d1c4c997b66 sys/netinet/in_proto.c
--- a/sys/netinet/in_proto.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/in_proto.c	Sun Aug 30 14:27:42 2015 +1000
@@ -82,6 +82,7 @@
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
 #include <netinet/ip_encap.h>
+#include <netinet/mptcp_var.h>
 
 /*
  * TCP/IP protocol family: IP, ICMP, UDP, TCP.
@@ -146,14 +147,14 @@
 	.pr_flags =		PR_CONNREQUIRED|PR_IMPLOPCL|PR_WANTRCVD,
 	.pr_input =		tcp_input,
 	.pr_ctlinput =		tcp_ctlinput,
-	.pr_ctloutput =		tcp_ctloutput,
+	.pr_ctloutput =		mp_ctloutput,
 	.pr_init =		tcp_init,
 #ifdef VIMAGE
 	.pr_destroy =		tcp_destroy,
 #endif
 	.pr_slowtimo =		tcp_slowtimo,
 	.pr_drain =		tcp_drain,
-	.pr_usrreqs =		&tcp_usrreqs
+	.pr_usrreqs =		&mptcp_usrreqs
 },
 #ifdef SCTP
 { 
diff -r 1d1c4c997b66 sys/netinet/mptcp.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp.h	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,93 @@
+/*-
+ * Copyright (c) 2012-2015
+ * 	Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams and
+ * Lawrence Stewart, made possible in part by a gift from the FreeBSD
+ * Foundation and The Cisco University Research Program Fund, a corporate
+ * advised fund of Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*
+ * mptcp.h
+ *
+ *  Created on: 15/05/2012
+ *      Author: nwilliams
+ */
+
+#ifndef MPTCP_H_
+#define MPTCP_H_
+
+
+#include <sys/cdefs.h>
+
+#define MPTCP_64BIT_KEY 8
+
+typedef	u_int64_t mptcp_seq;
+
+/* MPTCP subtypes */
+#define	MPTCP_SUBTYPE_MP_CAPABLE	0
+#define		MPTCP_SUBLEN_MP_CAPABLE_SYN	12
+#define		MPTCP_SUBLEN_MP_CAPABLE_ACK	20
+
+#define MPTCP_SUBTYPE_MP_JOIN		1
+#define		MPTCP_SUBLEN_MP_JOIN_SYN	12
+#define		MPTCP_SUBLEN_MP_JOIN_SYNACK	16		// should be 16, but run out of option space
+#define		MPTCP_SUBLEN_MP_JOIN_ACK	24		// should be 24, but run out of option space
+
+#define MPTCP_SUBTYPE_DSS			2
+#define		MPTCP_SUBLEN_DSS_DATA_ACK	XX
+#define		MPTCP_SUBLEN_DSS_DATA_DSN	XX
+
+#define MPTCP_SUBTYPE_ADD_ADDR		3
+#define 	MPTCP_SUBLEN_ADD_ADDRV4		8
+#define 	MPTCP_SUBLEN_ADD_ADDRV6		20
+
+#define MPTCP_SUBTYPE_REMOVE_ADDR	4
+#define 	MPTCP_SUBLEN_REMOVE_ADDR	4
+
+#define MPTCP_SUBTYPE_MP_PRIO		5
+
+#define MPTCP_SUBTYPE_MP_FAIL		6
+#define		MPTCP_SUBTYPELEN_MP_FAIL	12
+
+#define MPTCP_SUBTYPE_MP_FASTCLOSE	7
+#define 	MPTCP_SUBTYPELEN_MP_FASTCLOSE 12
+
+#define	MAX_MP_OPLEN	28
+
+/* mptcp errors */
+
+#define EMAXSUBFLOWSREACHED 01
+#define ENOMPCB	02
+#define	ENOTCPCB 03
+
+/* mptcp funcs */
+
+
+#define	MPTCP_SA_NAME_MAX	16	/* max scheduler discipline name length */
+
+#endif /* MPTCP_H_ */
diff -r 1d1c4c997b66 sys/netinet/mptcp_dtrace_declare.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_dtrace_declare.h	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,79 @@
+/*-
+ * Copyright (c) 2013-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+#ifndef MPTCP_DTRACE_DECLARE_H_
+#define MPTCP_DTRACE_DECLARE_H_
+
+#include "opt_kdtrace.h"
+#include <sys/kernel.h>
+#include <sys/sdt.h>
+
+/* Declare the MPTCP provider */
+SDT_PROVIDER_DECLARE(mptcp);
+
+/* Allocated a MPPCB */
+SDT_PROBE_DECLARE(mptcp, session, mpp_pcballoc, mppcb_alloc);
+
+/* Released a MPPCB */
+SDT_PROBE_DECLARE(mptcp, session, mpp_pcbrele, mppcb_release);
+
+/* Attached a MPCB */
+SDT_PROBE_DECLARE(mptcp, session, mp_attach, mpcb_attached);
+
+/* Discard a MPCB */
+SDT_PROBE_DECLARE(mptcp, session, mp_discardcb, entry);
+
+/* Info on connection becoming established */
+SDT_PROBE_DECLARE(mptcp, session, mp_init_established, estab_info);
+
+/* Setting options at the subflow level. */
+SDT_PROBE_DECLARE(mptcp, session, mp_setopt, entry);
+
+/* Getting options at the subflow level. */
+SDT_PROBE_DECLARE(mptcp, session, mp_getopt, entry);
+
+/* Setting options at the subflow level. */
+SDT_PROBE_DECLARE(mptcp, session, mp_process_subflow_event, connected);
+
+/* Local session key and token */
+SDT_PROBE_DECLARE(mptcp, session, mp_process_local_key, new_key);
+
+/* Foreign Host session key and token */
+SDT_PROBE_DECLARE(mptcp, session, mp_process_remote_key, new_key);
+
+/* Detach tcpcb from socket */
+SDT_PROBE_DECLARE(mptcp, session, tcp_detach, entry);
+
+
+#endif /* MPTCP_DTRACE_DECLARE_H_ */
diff -r 1d1c4c997b66 sys/netinet/mptcp_dtrace_define.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_dtrace_define.h	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,99 @@
+/*-
+ * Copyright (c) 2013-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+#ifndef MPTCP_DTRACE_DEFINE_H_
+#define MPTCP_DTRACE_DEFINE_H_
+
+#include "opt_kdtrace.h"
+#include <sys/kernel.h>
+#include <sys/sdt.h>
+
+SDT_PROVIDER_DEFINE(mptcp);
+
+/* Allocated a new mppcb */
+SDT_PROBE_DEFINE1(mptcp, session, mpp_pcballoc, mppcb_alloc,
+	"uintptr_t");    /* Pointer to mppcb struct allocated */
+
+/* Released a mppcb */
+SDT_PROBE_DEFINE1(mptcp, session, mpp_pcbrele, mppcb_release,
+	"uintptr_t");    /* Pointer to mppcb struct to be released */
+
+/* Attached MP transport block */
+SDT_PROBE_DEFINE1(mptcp, session, mp_attach, mpcb_attached,
+	"uintptr_t");    /* Pointer to mpcb struct attached to mppcb */
+
+/* Discard MP transport block */
+SDT_PROBE_DEFINE1(mptcp, session, mp_discardcb, entry,
+	"uintptr_t");    /* Pointer to mpcb struct to be discarded */
+
+/* MP session transitions to M_ESTABLISHED */
+SDT_PROBE_DEFINE5(mptcp, session, mp_init_established, estab_info,
+    "uint64_t",		/* Initial data-sequence send */
+    "uint64_t",		/* Initial data-sequence receive */
+    "uintptr_t",	/* The pointer to the struct mpcb */
+    "uint32_t",	    /* Local mp session token */
+    "uint32_t");	/* Remote mp session token */
+
+/* Setting socket options */
+SDT_PROBE_DEFINE3(mptcp, session, mp_setopt, entry,
+	"uintptr_t",    /* Pointer to mpcb struct */
+	"int_t",    /* Protocol level */
+	"int_t");	/* Option value */
+
+/* Getting socket options */
+SDT_PROBE_DEFINE3(mptcp, session, mp_getopt, entry,
+	"uintptr_t",    /* Pointer to mpcb struct */
+	"int_t",    /* Protocol level */
+	"int_t");	/* Option value */
+
+/* Generation of local key */
+SDT_PROBE_DEFINE2(mptcp, session, mp_process_subflow_event, connected,
+	"uintptr_t",    /* Pointer to mpcb struct */
+	"uintptr_t");   /* Pointer to tcbcb struct */
+
+/* Generation of local key */
+SDT_PROBE_DEFINE2(mptcp, session, mp_process_local_key, new_key,
+    "uint32_t",		/* Local session token */
+    "uint64_t");	/* Local key */
+
+/* Remote key and foreign host session token */
+SDT_PROBE_DEFINE2(mptcp, session, mp_process_remote_key, new_key,
+    "uint32_t",		/* Foreign host session token */
+    "uint64_t");	/* Remote key */
+
+SDT_PROBE_DEFINE1(mptcp, session, tcp_detach, entry,
+		"uintptr_t");   /* Pointer to struct socket */
+
+
+#endif /* MPTCP_DTRACE_DEFINE_H_ */
